function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}

$parcel$export(module.exports, "when", () => $882b6d93070905b3$export$a55877ca9db47377);
$parcel$export(module.exports, "code", () => $882b6d93070905b3$export$6565f9f03506010b);
$parcel$export(module.exports, "condition", () => $882b6d93070905b3$export$355ef19165780f94);
$parcel$export(module.exports, "eq", () => $882b6d93070905b3$export$9663ddc1cf085b32);
$parcel$export(module.exports, "block", () => $882b6d93070905b3$export$837bd02682cd3db9);
$parcel$export(module.exports, "result", () => $882b6d93070905b3$export$aaf36426b5008f7a);
$parcel$export(module.exports, "invoke", () => $882b6d93070905b3$export$468cda29b159ee5d);
$parcel$export(module.exports, "proxy", () => $882b6d93070905b3$export$923f96dd5afa9ce6);
$parcel$export(module.exports, "symbol", () => $882b6d93070905b3$export$8f701197936bc2a6);
$parcel$export(module.exports, "add", () => $882b6d93070905b3$export$e16d8520af44a096);
$parcel$export(module.exports, "or", () => $882b6d93070905b3$export$252bb8b3bbdf6749);
$parcel$export(module.exports, "and", () => $882b6d93070905b3$export$21c0ac7fe1cef1b8);
$parcel$export(module.exports, "sub", () => $882b6d93070905b3$export$f93b5905241a7cca);
$parcel$export(module.exports, "not", () => $882b6d93070905b3$export$6003a5f097c73977);
$parcel$export(module.exports, "defined", () => $882b6d93070905b3$export$43f40ad3fa1d5c97);
$parcel$export(module.exports, "mult", () => $882b6d93070905b3$export$30cdb7d48dedb58b);
$parcel$export(module.exports, "div", () => $882b6d93070905b3$export$159d9494db57879b);
$parcel$export(module.exports, "gte", () => $882b6d93070905b3$export$aac79e834d1b4aed);
$parcel$export(module.exports, "gt", () => $882b6d93070905b3$export$dafeacbfe3530cd9);
$parcel$export(module.exports, "lt", () => $882b6d93070905b3$export$b961576059b7aeb6);
$parcel$export(module.exports, "fallback", () => $882b6d93070905b3$export$bcd1dd1f397bba12);
$parcel$export(module.exports, "set", () => $882b6d93070905b3$export$adaa4cf7ef1b65be);
$parcel$export(module.exports, "declare", () => $882b6d93070905b3$export$2dd1b52e6ceca94e);
$parcel$export(module.exports, "executeOnly", () => $882b6d93070905b3$export$cf30d3d2f53b889d);
$parcel$export(module.exports, "execute", () => $882b6d93070905b3$export$51396ec711da548b);
$parcel$export(module.exports, "functions", () => $882b6d93070905b3$export$18af1f934c132a41);
$parcel$export(module.exports, "getDependencies", () => $882b6d93070905b3$export$75915f81f2a6540a);
$parcel$export(module.exports, "kotlin", () => $124e9cce005d8afc$export$b3890eb0ae9dca99);
$parcel$export(module.exports, "kotlinBundle", () => $124e9cce005d8afc$export$1f0ba71ea6f249e7);
$parcel$export(module.exports, "swift", () => $a9462d9f7870d0d5$export$b3890eb0ae9dca99);
$parcel$export(module.exports, "swiftBundle", () => $a9462d9f7870d0d5$export$1f0ba71ea6f249e7);
$parcel$export(module.exports, "javascript", () => $54ccefa5a416848d$export$b3890eb0ae9dca99);
$parcel$export(module.exports, "javascriptBundle", () => $54ccefa5a416848d$export$1f0ba71ea6f249e7);
const $124e9cce005d8afc$var$remap = {
    _: "Underscore"
};
const $124e9cce005d8afc$export$1f0ba71ea6f249e7 = ()=>`

import android.Manifest
import android.content.Intent
import android.content.pm.PackageManager
import android.os.Build
import android.os.Handler
import android.os.Looper
import android.speech.RecognizerIntent
import android.speech.tts.TextToSpeech
import android.util.Log
import androidx.core.app.ActivityCompat
import androidx.core.content.ContextCompat
import org.json.JSONArray
import org.json.JSONObject
import java.text.DecimalFormat
import java.text.DecimalFormatSymbols
import java.text.SimpleDateFormat
import java.util.*
import java.util.concurrent.locks.ReentrantLock
import kotlin.math.pow

fun getIdentifier(input : Any?) : Any? {
    if(input is Map<*, *>) {
        return input["key"] ?: input["id"]
    }
    return null
}

fun executor(max: Int, makeThread: (() -> Unit) -> Unit): (() -> Unit) -> Unit {
    val lock = ReentrantLock()
    val queue = LinkedList<() -> Unit>()
    var running = 0
    return {
        lock.lock()
        queue.add(it)
        if (running < max) {
            running++
            makeThread {
                while (true) {
                    lock.lock()
                    val next = queue.poll()
                    if (next != null) {
                        lock.unlock()
                        next()
                    } else {
                        running--
                        lock.unlock()
                        break
                    }
                }
            }
        }
        lock.unlock()
    }
}

val mainExecutor = executor(1) {
    Handler(Looper.getMainLooper()).post(it)
}

fun main(callback : () -> Unit) {
    if (Looper.myLooper() == Looper.getMainLooper()) {
        Log.d("executor", "already in main")
    }
    mainExecutor(callback)
}

val backgroundExecutor = executor(1) {
    Thread(it).start()
}

fun background(callback : () -> Unit) {
    if (Looper.myLooper() != Looper.getMainLooper()) {
        Log.d("executor", "already in background")
    }
    backgroundExecutor(callback)
}

interface Extension {
    fun call(vararg args: Any?): Any?
}

interface ArgumentCallback {
    fun call(args: Any?): Any?
}

val extensions = mutableMapOf<String, Extension>(
    "isSame" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val time = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val unit = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            if(receiver is ProgrammingMoment && unit is String && time is Double) {
                val moment = Calendar.getInstance()
                moment.timeInMillis = receiver.ms.toLong()
                val compare = Calendar.getInstance()
                compare.timeInMillis = time.toLong()
                if(unit == "day") {
                    return moment.get(Calendar.YEAR) == compare.get(Calendar.YEAR) && moment.get(Calendar.MONTH) == compare.get(Calendar.MONTH) && moment.get(Calendar.DAY_OF_MONTH) == compare.get(Calendar.DAY_OF_MONTH)
                }
            }
            throw NotImplementedError("isSame for $args")
        }
    },
    "api" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val config = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            if (config is Map<*, *>) {
                val data = config["data"]
                val execute = config["execute"]
                val callback = config["callback"]
                val json = JSON.stringify(mutableMapOf(
                    "data" to data,
                    "execute" to when(execute) {
                        is String -> JSON.parse(execute)
                        else -> ""
                    }
                ))
                val queue = com.android.volley.toolbox.Volley.newRequestQueue(MainActivity.activity)
                val url = "https://www.speaknatively.com/api"
                val stringRequest = object : com.android.volley.toolbox.StringRequest(
                        Method.POST,
                        url,
                        { response ->
                            if(callback is ArgumentCallback) {
                                callback.call(mutableMapOf(
                                        "data" to JSON.parse(response)
                                ))
                            }
                        },
                        {

                        },

                ) {
                    override fun getBodyContentType(): String {
                        return "application/json; charset=utf-8"
                    }

                    override fun getBody(): ByteArray {
                        return json.toByteArray(Charsets.UTF_8)
                    }
                }
                queue.add(stringRequest)
                return null
            }
            throw NotImplementedError("api for $args")
        }
    },
    "compare" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val a = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val b = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            if (receiver is ProgrammingUnderscore && a is Comparable<*> && b is Comparable<*>) {
                return (a as Comparable<Any?>).compareTo(b as Any?)
            }
            throw NotImplementedError("compare for $args")
        }
    },
    "start" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val config = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            if (receiver is PollySpeechRecognition && config is Map<*, *>) {
                val callback = config["onResult"]
                if (callback is ArgumentCallback) {
                    speechRecognitionCallback = callback
                    if (ContextCompat.checkSelfPermission(
                                    MainActivity.activity,
                                    Manifest.permission.RECORD_AUDIO
                            ) != PackageManager.PERMISSION_GRANTED
                    ) {
                        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
                            ActivityCompat.requestPermissions(
                                    MainActivity.activity,
                                    listOf(
                                            Manifest.permission.RECORD_AUDIO
                                    ).toTypedArray(),
                                    SPEECH_REQUEST_CODE
                            )
                        }
                    } else {
                        val intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
                        intent.putExtra(
                                RecognizerIntent.EXTRA_LANGUAGE_MODEL,
                                RecognizerIntent.LANGUAGE_MODEL_FREE_FORM
                        )
                        if(config.containsKey("lang")) {
                            val lang = config["lang"]
                            if(lang is String) {
                                intent.putExtra(
                                    RecognizerIntent.EXTRA_LANGUAGE,
                                    lang
                                )
                            }
                        }
                        MainActivity.activity.startActivityForResult(intent, SPEECH_RESULT_CODE)
                    }
                }
                return null
            }
            throw NotImplementedError("start for $args")
        }
    },
    "moment" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val ms = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            if (ms is Double) {
                return ProgrammingMoment(ms)
            }
            throw NotImplementedError("moment for $args")
        }
    },
    "includes" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val list = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val needle = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            if (receiver is ProgrammingUnderscore && list is List<*>) {
                return list.contains(needle)
            }
            throw NotImplementedError("includes for $args")
        }
    },
    "split" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val source = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val token = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            if(receiver is ProgrammingUnderscore && source is String && token is String) {
                return source.split(Regex(token))
            }
            throw NotImplementedError("toLowerCase for $args")
        }
    },
    "toLowerCase" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val string = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            if(receiver is ProgrammingUnderscore && string is String) {
                return string.toLowerCase()
            }
            throw NotImplementedError("toLowerCase for $args")
        }
    },
    "toString" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val radix = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            if (receiver is Double && radix is Double) {
                return receiver.toBigDecimal().toPlainString().split(".").map {
                    it.toLong().toString(radix.toInt())
                }.joinToString(".")
            }
            if (receiver is ProgrammingUnderscore) {
                if(radix is Double) {
                    val otherSymbols = DecimalFormatSymbols()
                    val df = DecimalFormat("#.##########", otherSymbols)
                    return df.format(radix)
                }
                return "$radix"
            }
            throw NotImplementedError("toString for $args")
        }
    },
    "substr" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val startIndex = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val endIndex = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            if (receiver is String && startIndex is Double && endIndex is Double) {
                return receiver.substring(startIndex.toInt(), endIndex.toInt())
            }
            if (receiver is String && startIndex is Double) {
                return receiver.substring(startIndex.toInt())
            }
            throw NotImplementedError("substr for $args")
        }
    },
    "assign" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val target = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val overwrite = when (args.size >= 1) {
                true -> args.asSequence().toList().subList(1, args.size)
                false -> null
            }
            val allMaps = overwrite?.all {
                it is MutableMap<*, *>
            } ?: false
            if (receiver is ProgrammingUnderscore && target is MutableMap<*, *> && allMaps) {
                return overwrite?.fold(mutableMapOf<String, Any?>()) { total, item ->
                    total.putAll(item as MutableMap<String, Any?>)
                    total
                }
            }
            throw NotImplementedError("assign for $args")
        }
    },
    "reduce" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val list = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val callback = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            val initial = when (args.size >= 4) {
                true -> args[3]
                false -> null
            }
            if (receiver is ProgrammingUnderscore && list is List<*> && callback is ArgumentCallback) {
                return list.foldIndexed(initial) { index, total, item ->
                    callback.call(
                            mapOf(
                                    "item" to item,
                                    "total" to total,
                                    "index" to index.toDouble()
                            )
                    )
                }
            }
            throw NotImplementedError("reduce for $args")
        }
    },
    "speak" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val config = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            if (receiver is PollyTTS && config is Map<*, *>) {
                val lang = config["lang"] as? String ?: "en-US"
                val rate = (config["rate"] as? Double ?: 1).toFloat()
                val text = config["text"] as? String ?: ""
                val tts = MainActivity.tts
                tts.language = Locale(lang)
                tts.setSpeechRate(rate)
                tts.speak(text, TextToSpeech.QUEUE_FLUSH, null)
                return null
            }
            throw NotImplementedError("speak for $args")
        }
    },
    "replace" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val haystack = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val needle = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            val replace = when (args.size >= 4) {
                true -> args[3]
                false -> null
            }
            if (receiver is ProgrammingUnderscore && haystack is String && needle is String && replace is String) {
                return haystack.replace(Regex(needle), replace)
            }
            throw NotImplementedError("replace for $args")
        }
    },
    "forEach" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val list = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val callback = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            if (receiver is ProgrammingUnderscore && list is List<*> && callback is ArgumentCallback) {
                return list.forEachIndexed { index, item ->
                    callback.call(
                            mapOf(
                                    "item" to item,
                                    "index" to index.toDouble()
                            )
                    )
                }
            }
            throw NotImplementedError("map for $args")
        }
    },
    "log" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val values = args.asList().subList(1, args.size)
            if (receiver is ProgrammingConsole) {
                Log.d("console.log", "$values")
                return null
            }
            throw NotImplementedError("log for $args")
        }
    },
    "pow" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val a = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val b = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            if (receiver is ProgrammingMath && a is Double && b is Double) {
                return a.pow(b)
            }
            throw NotImplementedError("pow for $args")
        }
    },
    "map" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val list = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val callback = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            if (receiver is ProgrammingUnderscore && list is List<*> && callback is ArgumentCallback) {
                return list.mapIndexed { index, item ->
                    callback.call(
                            mapOf(
                                    "item" to item,
                                    "index" to index.toDouble()
                            )
                    )
                }
            }
            throw NotImplementedError("map for $args")
        }
    },
    "filter" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val list = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val callback = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            if (receiver is ProgrammingUnderscore && list is List<*> && callback is ArgumentCallback) {
                return list.filter { item ->
                    hasValue(
                            callback.call(
                                    mapOf(
                                            "item" to item
                                    )
                            )
                    )
                }
            }
            throw NotImplementedError("filter for $args")
        }
    },
    "indexOf" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val list = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val callback = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            if (receiver is ProgrammingUnderscore && list is List<*> && callback is ArgumentCallback) {
                val item = list.find { item ->
                    hasValue(
                            callback.call(
                                    mapOf(
                                            "item" to item
                                    )
                            )
                    )
                }
                return list.indexOf(item).toDouble()
            }
            throw NotImplementedError("indexOf for $args")
        }
    },
    "date" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val config = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            if (receiver is PollyPicker && config is Map<*, *>) {
                receiver.date(config as Map<String, Any?>)
                return null
            }
            throw NotImplementedError("date for $args")
        }
    },
    "find" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val list = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val callback = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            val or = when (args.size >= 4) {
                true -> args[3]
                false -> null
            }
            if (receiver is ProgrammingUnderscore && list is List<*> && callback is ArgumentCallback) {
                return list.find { item ->
                    hasValue(
                            callback.call(
                                    mapOf(
                                            "item" to item
                                    )
                            )
                    )
                } ?: or
            }
            throw NotImplementedError("find for $args")
        }
    },
    "every" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val list = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val callback = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            if (receiver is ProgrammingUnderscore && list is List<*> && callback is ArgumentCallback) {
                return list.all { item ->
                    hasValue(
                            callback.call(
                                    mapOf(
                                            "item" to item
                                    )
                            )
                    )
                }
            }
            throw NotImplementedError("every for $args")
        }
    },
    "some" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val list = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val callback = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            if (receiver is ProgrammingUnderscore && list is List<*> && callback is ArgumentCallback) {
                return list.any { item ->
                    hasValue(
                            callback.call(
                                    mapOf(
                                            "item" to item
                                    )
                            )
                    )
                }
            }
            throw NotImplementedError("some for $args")
        }
    },
    "sort" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val list = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val callback = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            if (receiver is ProgrammingUnderscore && list is List<*> && callback is ArgumentCallback) {
                return list.sortedWith { a, b ->
                    (callback.call(
                            mapOf(
                                    "a" to a,
                                    "b" to b
                            )
                    ) as Number).toInt()
                }
            }
            throw NotImplementedError("sort for $args")
        }
    },
    "concat" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val target = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val rest = when (args.size >= 3) {
                true -> args.asSequence().toList().subList(2, args.size)
                false -> null
            }
            val isLists = rest?.all {
                it is List<*>
            } ?: false
            if (receiver is ProgrammingUnderscore && target is List<*> && isLists) {
                return rest?.fold(target) { total, item ->
                    total + (item as List<Map<String, Any?>>)
                }
            }
            throw NotImplementedError("concat for $args")
        }
    },
    "upsert" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val haystack = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val needle = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            if (receiver is ProgrammingUnderscore && haystack is List<*> && needle is MutableMap<*, *>) {
                val item = haystack.find {
                    it is MutableMap<*, *> && getIdentifier(it) == getIdentifier(needle)
                }
                if (item is MutableMap<*, *>) {
                    val index = haystack.indexOf(item)
                    return haystack.subList(0, index) + listOf(needle) + haystack.subList(
                            index + 1,
                            haystack.size
                    )
                } else {
                    return haystack + listOf(needle)
                }
            }
            throw NotImplementedError("upsert for $args")
        }
    },
    "slice" to object : Extension {
        override fun call(vararg args: Any?): Any? {
            val receiver = args[0]
            val target = when (args.size >= 2) {
                true -> args[1]
                false -> null
            }
            val from = when (args.size >= 3) {
                true -> args[2]
                false -> null
            }
            val tempTo = when (args.size >= 4) {
                true -> args[3]
                false -> null
            }
            if (receiver is ProgrammingUnderscore && target is MutableList<*> && from is Double && tempTo is Double?) {
                val to = tempTo ?: target.size.toDouble()
                return if(to > target.size) {
                    target.subList(from.toInt(), target.size)
                } else if(to < 0) {
                    target.subList(from.toInt(), (target.size + to).toInt())
                } else if(from >= to) {
                    mutableListOf()
                } else {
                    target.subList(from.toInt(), to.toInt())
                }
            }
            if (receiver is ProgrammingUnderscore && target is String && from is Double && tempTo is Double?) {
                val to = tempTo ?: target.length.toDouble()
                return if(to > target.length) {
                    target.substring(from.toInt(), target.length)
                } else if(to < 0) {
                    target.substring(from.toInt(), (target.length + to).toInt())
                } else if(from >= to) {
                    ""
                } else {
                    target.substring(from.toInt(), to.toInt())
                }
            }
            throw NotImplementedError("slice for $args")
        }
    }
)

class PollyTTS

class ProgrammingMoment(
        val ms: Double
) {
    fun format(format: String): String {
        val formatter = SimpleDateFormat(
                format
                        .replace("ddd", "E") // show proper day name
                        .replace("D", "d") // show proper date
        )
        val calendar = Calendar.getInstance()
        calendar.timeInMillis = ms.toLong()
        return formatter.format(calendar.time)
    }

    fun startOf(field: String): ProgrammingMoment {
        val cal = Calendar.getInstance()
        cal.timeInMillis = ms.toLong()
        if (listOf("year").contains(field)) {
            cal.set(Calendar.MONTH, 0)
        }
        if (listOf("year", "month").contains(field)) {
            cal.set(Calendar.DAY_OF_MONTH, 0)
        }
        if (listOf("year", "month", "day").contains(field)) {
            cal.set(Calendar.HOUR, 0)
        }
        if (listOf("year", "month", "day", "hour").contains(field)) {
            cal.set(Calendar.MINUTE, 0)
        }
        if (listOf("year", "month", "day", "hour", "minute").contains(field)) {
            cal.set(Calendar.SECOND, 0)
        }
        if (listOf("year", "month", "day", "hour", "minute", "second").contains(field)) {
            cal.set(Calendar.MILLISECOND, 0)
        }
        return ProgrammingMoment(cal.timeInMillis.toDouble())
    }

    fun valueOf(): Double {
        return ms
    }
}

class JSON {
    companion object {
        fun parse(input: String?): MutableMap<String, Any?>? {
            if(input == null) return null
            return parse(JSONObject(input)) as MutableMap<String, Any?>
        }

        private fun parse(input: Any?): Any? {
            if (input is JSONArray) {
                return 0.until(input.length()).fold(mutableListOf<Any?>()) { total, index ->
                    total.add(parse(input[index]))
                    total
                }
            }
            if (input is JSONObject) {
                return input.keys().asSequence().toList()
                    .fold(mutableMapOf<String, Any?>()) { total, key ->
                        total[key] = parse(input.get(key))
                        total
                    }
            }
            if(input is Number) {
                return input.toDouble()
            }
            return input
        }

        fun stringify(input: MutableMap<String, Any?>?): String {
            return stringify(input as Any?).toString()
        }

        private fun stringify(input: Any?): Any? {
            if (input is Map<*, *>) {
                return input.keys.toList().fold(JSONObject()) { total, key ->
                    if (key is String) {
                        total.put(key, stringify(input[key]))
                    }
                    total
                }
            }
            if (input is List<*>) {
                return input.fold(JSONArray()) { total, item ->
                    total.put(stringify(item))
                    total
                }
            }
            return input
        }
    }
}

fun setTimeout(callback: () -> Unit, ms: Long) {
    Handler(Looper.getMainLooper()).postDelayed({
        background {
            callback()
            updateAll("setTimeout")
        }
    }, ms)
}

class ProgrammingDate {
    fun now(): Double {
        return System.currentTimeMillis().toDouble()
    }
}

class ProgrammingMath {
    fun random(): Double {
        return java.lang.Math.random()
    }
}

class ProgrammingUnderscore

class ProgrammingConsole

fun invoke(target: Any?, name: String, args: List<Any?>): Any? {
    val types = args.map {
        it?.javaClass
    }.toTypedArray()
    if(target != null) {
        try {
            return target.javaClass.getMethod(name, *types).invoke(target, *args.toTypedArray())
        } catch (e: NoSuchMethodException) {
        }
    }
    val method = extensions[name]
    if (method != null) {
        return method.call(target, *args.toTypedArray())
    }
    throw NotImplementedError("$name for $target")
}

fun get(path: List<Any?>): Any? {
    if (path.isEmpty()) return extensions
    return path.subList(1, path.size).fold(path.first(), { target, key ->
        if (target is Map<*, *> && key is String) {
            (target as MutableMap<String, Any?>)[key]
        } else if (target is List<*>) {
            when (key) {
                is Double -> {
                    val index = key.toInt()
                    val list = target as MutableList<Any>
                    if (0 <= index && index < list.size) {
                        list[index]
                    } else {
                        null
                    }
                }
                "length" -> target.size.toDouble()
                else -> throw NotImplementedError("get $key for $target")
            }
        } else {
            return null
            // throw NotImplementedError("get $key for $target")
        }
    })
}

fun set(path: List<Any?>, value: Any?): Any? {
    if (path.size <= 1) return value
    val target = get(path.subList(0, path.size - 1))
    val key = path.last()
    if (target is MutableMap<*, *> && key is String) {
        (target as MutableMap<String, Any?>)[key] = value
        return value
    } else if (target is MutableList<*> && key is Double) {
        val list = target as MutableList<Any?>
        val index = key.toInt()
        while (index >= list.size) {
            list.add(null)
        }
        list[index] = value
        return value
    } else if (target is Component && key is String) {
        target.set(key, value)
        return value
    } else {
        throw NotImplementedError("set $key for $target")
    }
}

fun hasValue(input: Any?): Boolean {
    if ((input == "").or(input == false).or(input == null).or(input == 0)) {
        return false
    }
    return true
}

val nf = DecimalFormat("0.#")

fun add(vararg inputs: Any?): Any? {
    return inputs.asSequence().toList().subList(1, inputs.size).fold(inputs[0], { total, input ->
        if (total is Double && input is String) {
            nf.format(total) + input
        } else if (total is String && input is Double) {
            total + nf.format(input)
        } else if (total is Double && input is Double) {
            total + input
        } else {
            total.toString() + input.toString()
        }
    })
}

fun div(vararg inputs: Any?): Any? {
    return inputs.asSequence().toList().subList(1, inputs.size).fold(inputs[0], { total, number ->
        if (total is Double && number is Double) {
            total / number
        } else {
            total
        }
    })
}

fun sub(vararg inputs: Any?): Any? {
    return inputs.asSequence().toList().subList(1, inputs.size).fold(inputs[0], { total, number ->
        if (total is Double && number is Double) {
            total - number
        } else {
            total
        }
    })
}

fun mult(vararg inputs: Any?): Any? {
    return inputs.fold(1.0, { total, number ->
        if (number is Double) {
            total * number
        } else {
            total
        }
    })
}

fun gt(a: Any?, b: Any?): Boolean {
    if (a is Double && b is Double) {
        return a > b
    }
    return false
}

fun lt(a: Any?, b: Any?): Boolean {
    if (a is Double && b is Double) {
        return a < b
    }
    return false
}

fun gte(a: Any?, b: Any?): Boolean {
    if (a is Double && b is Double) {
        return a >= b
    }
    return false
}

fun not(input: Any?): Boolean {
    if (input is Boolean) {
        return input.not()
    }
    return !hasValue(input)
}

val Date = ProgrammingDate()
val Underscore = ProgrammingUnderscore()
val Math = ProgrammingMath()
val console = ProgrammingConsole()`
;
const $124e9cce005d8afc$export$b3890eb0ae9dca99 = (code, tabs)=>{
    if (code === null) return "null";
    if (code === undefined) return "null";
    switch(code._name){
        case "result":
            return `${tabs}return ${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.value, tabs)}`;
        case "declare":
            {
                const variables = Object.keys(code.variables).map(// @ts-ignore
                (key)=>`${tabs}var ${key}: Any? = ${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.variables[key], tabs)}`
                ).join("\n");
                const body = code.body.map((it)=>$124e9cce005d8afc$export$b3890eb0ae9dca99(it, tabs)
                ).join("\n");
                return `${variables}${variables ? `\n${body}` : body}`;
            }
        case "fallback":
            return `(${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.value, tabs)} ?: ${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.fallback, tabs)})`;
        case "get":
            {
                const rest = code.variable.slice(1).map((it)=>$124e9cce005d8afc$export$b3890eb0ae9dca99(it, tabs)
                ).join(", ");
                // @ts-ignore
                const name = $124e9cce005d8afc$var$remap[code.variable[0]] ?? code.variable[0];
                return `get(
${tabs}\tlistOf(
${tabs}\t\t${typeof name === "string" ? name : $124e9cce005d8afc$export$b3890eb0ae9dca99(name, `${tabs}\t\t`)}${rest ? `,
${tabs}\t\t${rest}` : ""}
${tabs}\t)
${tabs})`;
            }
        case "set":
            return `${tabs}${code.variable.length <= 1 ? `${code.variable[0]} = ` : ""}set(
${tabs}\tlistOf(
${tabs}\t\t${code.variable[0]},
${tabs}\t\t${code.variable.slice(1).map((it)=>$124e9cce005d8afc$export$b3890eb0ae9dca99(it, `${tabs}\t\t\t`)
            ).join(`,\n${tabs}\t\t\t`)}
${tabs}\t),
${tabs}\t${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.value, `${tabs}\t`)}
${tabs})`;
        case "not":
            return `not(${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.item, tabs)})`;
        case "add":
            return "add(" + code.items.map((it)=>$124e9cce005d8afc$export$b3890eb0ae9dca99(it, tabs)
            ).join(", ") + ")";
        case "sub":
            return "sub(" + code.items.map((it)=>$124e9cce005d8afc$export$b3890eb0ae9dca99(it, tabs)
            ).join(", ") + ")";
        case "mult":
            return "mult(" + code.items.map((it)=>$124e9cce005d8afc$export$b3890eb0ae9dca99(it, tabs)
            ).join(", ") + ")";
        case "div":
            return "div(" + code.items.map((it)=>$124e9cce005d8afc$export$b3890eb0ae9dca99(it, tabs)
            ).join(", ") + ")";
        case "or":
            return code.items.slice(1).reduce((bool, next)=>`hasValue(${bool}).or(hasValue(${$124e9cce005d8afc$export$b3890eb0ae9dca99(next, tabs)}))`
            , $124e9cce005d8afc$export$b3890eb0ae9dca99(code.items[0], tabs));
        case "and":
            return code.items.slice(1).reduce((bool, next)=>`hasValue(${bool}).and(hasValue(${$124e9cce005d8afc$export$b3890eb0ae9dca99(next, tabs)}))`
            , $124e9cce005d8afc$export$b3890eb0ae9dca99(code.items[0], tabs));
        case "gt":
            return `gt(${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.a, tabs)}, ${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.b, tabs)})`;
        case "lt":
            return `lt(${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.a, tabs)}, ${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.b, tabs)})`;
        case "gte":
            return `gte(${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.a, tabs)}, ${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.b, tabs)})`;
        case "eq":
            return `(${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.a, tabs)} == ${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.b, tabs)})`;
        case "condition":
            {
                const otherwise = code.otherwise ? ` else {
${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.otherwise, tabs + "\t")}
${tabs}}` : "";
                return `${tabs}if(hasValue(${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.test, tabs)})) {
${$124e9cce005d8afc$export$b3890eb0ae9dca99(code.then, tabs + "\t")}
${tabs}}${otherwise}`;
            }
        case "defined":
            {
                const value = $124e9cce005d8afc$export$b3890eb0ae9dca99(code.item, tabs);
                return `(${value} !== null)`;
            }
        case "fun":
            {
                const body = [
                    ...code.args.map((it)=>`${tabs}\t\tval ${it} = get(listOf(args, "${it}"))`
                    ),
                    $124e9cce005d8afc$export$b3890eb0ae9dca99(code.body, `${tabs}\t\t`)
                ];
                if (code.name) return `extensions["${code.name}"] = object : Extension {
${tabs}override fun call(vararg list: Any?): Any? {
${tabs}\t${code.args.length ? "val args = list[1]" : ""}
${body.join("\n")}
${tabs}\t\treturn null
${tabs}\t}
${tabs}}`;
                return `object : ArgumentCallback {
${tabs}\toverride fun call(args: Any?): Any? {
${body.join("\n")}
${tabs}\t\treturn null
${tabs}\t}
${tabs}}`;
            }
        case "invoke":
            {
                const target = $124e9cce005d8afc$export$b3890eb0ae9dca99(code.target, `${tabs}\t`);
                const fun = code.fun;
                const args = code.args.map((it)=>$124e9cce005d8afc$export$b3890eb0ae9dca99(it, `${tabs}\t\t`)
                );
                const sideEffect = code.sideEffect;
                return `${sideEffect ? tabs : ""}invoke(
${tabs}\t${target},
${tabs}\t"${fun}",
${tabs}\tlistOf${args.length ? "" : "<Any>"}(
${tabs}\t\t${args.join(`,\n${tabs}\t\t`)}
${tabs}\t)
${tabs})`;
            }
        case "execute":
            return "";
        default:
            // @ts-ignore
            if (code instanceof Array) {
                const content = `
${tabs}\t${// @ts-ignore
                code.map((it)=>$124e9cce005d8afc$export$b3890eb0ae9dca99(it, `${tabs}\t`)
                ).join(`,\n${tabs}\t`)}
${tabs}`;
                // @ts-ignore
                return `mutableListOf<Any?>(${code.length ? content : ""})`;
            }
            if (typeof code === "object") {
                const keys = Object.keys(code);
                return keys.length ? `mutableMapOf<String, Any?>(
${tabs}\t${keys.map((key)=>`"${key}" to ${$124e9cce005d8afc$export$b3890eb0ae9dca99(code[key], `${tabs}\t`)}`
                ).join(`,\n\t${tabs}`)}
${tabs})` : "mutableMapOf<String, Any?>()";
            }
            if (typeof code === "number") return `(${code}).toDouble()`;
            return JSON.stringify(code);
    }
};


const $a9462d9f7870d0d5$export$1f0ba71ea6f249e7 = ()=>`
var ProgrammingGlobal : [String : (_ any : [Any?]) -> Any?] = [
    "slice" : { any in
        if let target = any[1] as? String, let from = any[2] as? Double {
            if any.count >= 4, let to = any[3] as? Double {
                if(to < 0) {
                    let start = target.index(target.startIndex, offsetBy: Int(from))
                    let end = target.index(target.startIndex, offsetBy: target.count + Int(to))
                    return String(target[start..<end])
                } else if(to > from) {
                    let start = target.index(target.startIndex, offsetBy: Int(from))
                    let end = target.index(target.startIndex, offsetBy: Int(to))
                    return String(target[start..<end])
                } else {
                    return ""
                }
            } else {
                let start = target.index(target.startIndex, offsetBy: Int(from))
                let end = target.index(target.startIndex, offsetBy: target.count)
                return String(target[start..<end])
            }
        }
        if let target = any[1] as? [Any?], let from = any[2] as? Double {
            if any.count >= 4, let to = any[3] as? Double {
                if(to < 0) {
                    let start = target.index(target.startIndex, offsetBy: Int(from))
                    let end = target.index(target.startIndex, offsetBy: target.count + Int(to))
                    return Array(target[start..<end])
                } else if(to > from) {
                    let start = target.index(target.startIndex, offsetBy: Int(from))
                    let end = target.index(target.startIndex, offsetBy: Int(to))
                    return Array(target[start..<end])
                } else {
                    return []
                }
            } else {
                let start = target.index(target.startIndex, offsetBy: Int(from))
                let end = target.index(target.startIndex, offsetBy: target.count)
                return Array(target[start..<end])
            }
        }
        return []
    },
    "toString" : { any in
        if any.count >= 3, let target = any[1] as? Double, let radix = any[2] as? Double {
            if radix == 16 {
                return String(format : "%02X", target)
            }
        }
        if any.count >= 2 {
            if let target = any[0] as? Double, let radix = any[1] as? Double {
                if radix == 16 {
                    return String(format : "%02X", target)
                }
            }
            if let target = any[1] as? Double {
                return target.truncatingRemainder(dividingBy: 1) == 0 ? String(format: "%.0f", target) : String(target)
            }
        }
        return String(describing: any[1])
    },
    "substr" : { any in
        if
            any.count == 2,
            let target = any[0] as? String,
            let start = any[1] as? Double {
            let from = target.index(target.startIndex, offsetBy: Int(start))
            return String(target[from...])
        }
        if
            any.count == 3,
            let target = any[0] as? String,
            let start = any[1] as? Double,
            let end = any[2] as? Double {
            let from = target.index(target.startIndex, offsetBy: Int(start))
            let to = target.index(target.startIndex, offsetBy: Int(end))
            return String(target[from..<to])
        }
        return nil
    }
]

func setTimeout(ms : Double, callback : @escaping () -> ()) {
    DispatchQueue.main.asyncAfter(deadline: .now() + (ms / 1000.0)) {
        callback()
    }
}

var ProgrammingMath : [String : (_ any : [Any?]) -> Any?] = [
    "random" : { any in
        return Double(arc4random()) / Double(UINT32_MAX)
    }
]

var ProgrammingUnderscore : [String : (_ any : [Any?]) -> Any?] = [
    "compare" : { any in
        if let a = any[0] as? String, let b = any[1] as? String {
            let cr = a.compare(b)
            if cr == .orderedAscending {
                return Double(-1)
            }
            if cr == .orderedDescending {
                return Double(1)
            }
            return Double(0)
        }
        if let a = any[0] as? Double, let b = any[1] as? Double {
            return a - b
        }
        return 0
    },
    "upsert" : { any in
        if let list = any[0] as? [[String : Any?]],
           let item = any[1] as? [String : Any?] {
            let outerKey = getIdentifier(input : item)
            let index = list.firstIndex(where : { member in
                let innerKey = getIdentifier(input : member)
                return outerKey == innerKey
            }) ?? -1
            if index == -1 {
                return Array(list + [item])
            } else {
                let left = Array(list[0..<index])
                let right = Array(list[(index + 1)...])
                return Array(left + [item] + right)
            }
        }
        return nil
    },
    "indexOf" : { any in
        if 
            let target = any[0] as? [Any?], 
            let callback = any[1] as? (Any?) -> Any? {
            return Double(target.firstIndex(where : { item in
                return callback([
                    "item" : item
                ]) as? Bool ?? false
            }) ?? -1)
        }
        return nil
    },
    "find" : { any in
        if 
            let target = any[0] as? [Any?], 
            let callback = any[1] as? (Any?) -> Any? {
            return target.first(where : { item in
                return callback([
                    "item" : item
                ]) as? Bool ?? false
            }) ?? any[2]
        }
        return nil
    },
    "sort" : { any in
        if var target = any[0] as? [Any?], let callback = any[1] as? (Any?) -> Any? {
            target.sort {
                let value = callback([
                    "a" : $0,
                    "b" : $1
                ]) as? Double ?? 0
                return value < 0
            }
            return target
        }
        return nil
    },
    "includes" : { any in
        if let haystack = any[0] as? [Any?], let needle = any[1] {
            return haystack.contains {
                return equals(a : $0, b : needle)
            }
        }
        return nil
    },
    "assign": { any in
        if let maps = any as? [[String : Any?]] {
            var map = maps[0]
            for overwrite in maps[1...] {
                for (k, v) in overwrite {
                    map[k] = v
                }
            }
            return map
        }
        return nil
    },
    "reduce" : { any in
        if let target = any[0] as? [Any?], let callback = any[1] as? (Any?) -> Any?, let initial = any[2] as Any? {
            return target.reduce(initial) { total, item in
                return callback([
                    "item" : item,
                    "total": total
                ])
            }
        }
        return nil
    },
    "some" : { any in
        if let target = any[0] as? [Any?], let callback = any[1] as? (Any?) -> Any? {
            return target.contains {
                return hasValue(input : callback([
                    "item" : $0
                ]))
            }
        }
        return nil
    },
    "replace" : { any in
        if let haystack = any[0] as? String, let needle = any[1] as? String, let replace = any[2] as? String {
            return haystack.replacingOccurrences(of: needle, with: replace, options: .regularExpression, range: nil)
        }
        return nil
    },
    "map" : { any in
        if let target = any[0] as? [Any?], let callback = any[1] as? (Any?) -> Any? {
            return target.map {
                return callback([
                    "item" : $0
                ])
            }
        }
        return nil
    },
    "filter" : { any in
        if let target = any[0] as? [Any?], let callback = any[1] as? (Any?) -> Any? {
            return target.filter {
                return hasValue(input : callback([
                    "item" : $0
                ]))
            }
        }
        return nil
    },
    "concat" : { any in
        if let arrays = any as? [[Any?]] {
            var array: [Any?] = []
            for append in arrays {
                array += append
            }
            return array
        }
        return nil
    }
]

var ProgrammingDate : [String : (_ any : [Any?]) -> Any?] = [
    "now" : { any in
        return Double(Date().timeIntervalSince1970 * 1000)
    }
]

func gt(a : Any?, b : Any?) -> Bool {
    if let a = a as? Double, let b = b as? Double {
        return a > b
    }
    return false
}

func gte(a : Any?, b : Any?) -> Bool {
    if let a = a as? Double, let b = b as? Double {
        return a >= b
    }
    return false
}

func add(input : [Any?]) -> Any? {
    return input[1...].reduce(input[0], { total, item in
        if let total = total as? Double, let item = item  as? Double {
            return total + item
        }
        if let total = total as? String, let item = item  as? Double {
            return total + String(format : "%g", item)
        }
        if let total = total as? Double, let item = item  as? String {
            return String(format : "%g", total) + item
        }
        if let total = total as? String, let item = item as? String {
            return total + item
        }
        return total
    })
}

func sub(input : [Any?]) -> Any? {
    return input[1...].reduce(input[0], { total, item in
        if let total = total as? Double, let item = item  as? Double {
            return total - item
        }
        return total
    })
}

func div(input : [Any?]) -> Any? {
    return input[1...].reduce(input[0], { total, item in
        if let total = total as? Double, let item = item  as? Double {
            return total / item
        }
        return total
    })
}

func mult(input : [Any?]) -> Any? {
    return input[1...].reduce(input[0], { total, item in
        if let total = total as? Double, let item = item  as? Double {
            return total * item
        }
        return total
    })
}

func not(input : Any?) -> Bool {
    return !hasValue(input: input)
}

func isEqual<T: Equatable>(type: T.Type, a: Any, b: Any) -> Bool {
    guard let a = a as? T, let b = b as? T else {
        return false
    }

    return a == b
}

func equals(a: Any?, b: Any?) -> Bool {
    if a == nil && b == nil {
        return true
    }
    if a == nil || b == nil {
        return false
    }
    if let a = a as? String, let b = b as? String {
        return isEqual(type: String.self, a: a, b : b)
    }
    if let a = a as? Double, let b = b as? Double {
        return isEqual(type: Double.self, a: a, b : b)
    }
    if let a = a as? Bool, let b = b as? Bool {
        return isEqual(type: Bool.self, a: a, b : b)
    }
    return false
}

func hasValue(input : Any?) -> Bool {
    if input == nil {
        return false
    }
    if let string = input as? String {
        return string != ""
    }
    if let double = input as? Double {
        return double != 0
    }
    if let bool = input as? Bool {
        return bool
    }
    return true
}

func get(
    root: Any?,
    path: [Any?]
) -> Any? {
    return path.reduce(root, { total, part in
        if let total = total as? [String : Any?], let part = part as? String {
            return total[part]
        }
        if let total = total as? [Any?] {
            if let part = part as? Double {
                if 0 <= part && Int(part) < total.count {
                    return total[Int(part)]
                } else {
                    return nil
                }
            }
            if let part = part as? String, part == "length" {
                return Double(total.count)
            }
        }
        return total
    })
}

func set(
    root: Any?,
    path: [Any?],
    value: Any?
) -> Any? {
    if path.isEmpty {
        return value
    }
    let part = path[0]
    if var root = root as? [String : Any?], let part = part as? String {
        root[part] = set(root : root[part], path : Array(path[1...]), value : value)
        return root
    }
    if var root = root as? [Any?], let part = part as? Double {
        root[Int(part)] = set(root : root[Int(part)], path : Array(path[1...]), value : value)
        return root
    }
    return value
}

func invoke(
    target: Any?,
    name: String,
    args: [Any?]
) -> Any? {
    if let target = target as? [String : Any?] {
        if let callback = target[name] as? ([Any?]) -> Any? {
            return callback(args)
        }
    }
    if let callback = ProgrammingGlobal[name] as? ([Any?]) -> Any? {
        return callback([target] + args)
    }
    return nil
}
`
;
const $a9462d9f7870d0d5$var$remap = {
    _: "ProgrammingUnderscore",
    Date: "ProgrammingDate",
    Math: "ProgrammingMath"
};
const $a9462d9f7870d0d5$export$b3890eb0ae9dca99 = (code, tabs)=>{
    if (code === undefined) return "nil";
    if (code === null) return "nil";
    switch(code._name){
        case "result":
            return `${tabs}return ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.value, tabs)}`;
        case "declare":
            {
                const variables = Object.keys(code.variables).map(// @ts-ignore
                (key)=>`${tabs}var ${key}: Any? = ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.variables[key], tabs)}`
                ).join("\n");
                const body = code.body.map((it)=>$a9462d9f7870d0d5$export$b3890eb0ae9dca99(it, tabs)
                ).join("\n");
                return `${variables}${variables ? `\n${body}` : body}`;
            }
        case "fallback":
            return `${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.value, tabs)} ?? ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.fallback, tabs)}`;
        case "get":
            {
                const rest = code.variable.slice(1).map((it)=>$a9462d9f7870d0d5$export$b3890eb0ae9dca99(it, tabs)
                ).join(", ");
                // @ts-ignore
                const name = $a9462d9f7870d0d5$var$remap[code.variable[0]] ?? code.variable[0];
                return `get(
${tabs}\troot : ${typeof name === "string" ? name : $a9462d9f7870d0d5$export$b3890eb0ae9dca99(name, `${tabs}\t\t`)},
${tabs}\tpath : [${rest ? `\n${tabs}\t\t${rest}\n${tabs}\t` : ""}]
${tabs})`;
            }
        case "set":
            return `${tabs}${code.variable[0]} = set(
${tabs}\troot : ${code.variable[0]},
${tabs}\tpath : [
${tabs}\t\t${code.variable.slice(1).map((it)=>$a9462d9f7870d0d5$export$b3890eb0ae9dca99(it, `${tabs}\t\t\t`)
            ).join(`,\n${tabs}\t\t\t`)}
${tabs}\t],
${tabs}\tvalue: ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.value, `${tabs}\t`)}
${tabs})`;
        case "not":
            return `not(input : ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.item, tabs)})`;
        case "add":
            return "add(input : [" + code.items.map((it)=>$a9462d9f7870d0d5$export$b3890eb0ae9dca99(it, tabs)
            ).join(", ") + "])";
        case "sub":
            return "sub(input : [" + code.items.map((it)=>$a9462d9f7870d0d5$export$b3890eb0ae9dca99(it, tabs)
            ).join(", ") + "])";
        case "mult":
            return "mult(input : [" + code.items.map((it)=>$a9462d9f7870d0d5$export$b3890eb0ae9dca99(it, tabs)
            ).join(", ") + "])";
        case "div":
            return "div(input : [" + code.items.map((it)=>$a9462d9f7870d0d5$export$b3890eb0ae9dca99(it, tabs)
            ).join(", ") + "])";
        case "or":
            return "(" + code.items.map((it)=>`hasValue(input : ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(it, tabs)})`
            ).join(" || ") + ")";
        case "and":
            return "(" + code.items.map((it)=>`hasValue(input : ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(it, tabs)})`
            ).join(" && ") + ")";
        case "gt":
            return `gt(a : ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.a, tabs)}, b : ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.b, tabs)})`;
        case "lt":
            return `lt(a : ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.a, tabs)}, b : ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.b, tabs)})`;
        case "gte":
            return `gte(a : ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.a, tabs)}, b : ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.b, tabs)})`;
        case "eq":
            return `equals(a : ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.a, tabs)}, b : ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.b, tabs)})`;
        case "condition":
            {
                const otherwise = code.otherwise ? ` else {
${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.otherwise, tabs + "\t")}
${tabs}}` : "";
                return `${tabs}if(hasValue(input : ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.test, tabs)})) {
${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.then, tabs + "\t")}
${tabs}}${otherwise}`;
            }
        case "defined":
            {
                const value = $a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.item, tabs);
                return `hasValue(input : ${value})`;
            }
        case "fun":
            {
                const body = [
                    ...code.args.map((it)=>`${tabs}\tvar ${it} = get(root : args, path : ["${it}"])`
                    ),
                    $a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.body, `${tabs}\t`)
                ];
                if (code.name) return `${tabs}ProgrammingGlobal["${code.name}"] = { list in
${tabs}\t${code.args.length ? "let args = list[1]" : ""}
${body.join("\n")}
${tabs}\treturn nil
${tabs}}`;
                return `{ (args : Any?) -> Any? in
${body.join("\n")}
${tabs}\treturn nil
${tabs}}`;
            }
        case "execute":
            return "";
        case "invoke":
            {
                const target = $a9462d9f7870d0d5$export$b3890eb0ae9dca99(code.target, `${tabs}\t`);
                const fun = code.fun;
                const args = code.args.map((it)=>$a9462d9f7870d0d5$export$b3890eb0ae9dca99(it, `${tabs}\t\t`)
                );
                const sideEffect = code.sideEffect;
                return `${sideEffect ? tabs : ""}invoke(
${tabs}\ttarget : ${target},
${tabs}\tname : "${fun}",
${tabs}\targs : [
${tabs}\t\t${args.join(`,\n${tabs}\t\t`)}
${tabs}\t]
${tabs})`;
            }
        default:
            // @ts-ignore
            if (code instanceof Array) {
                const content = `
${tabs}\t${// @ts-ignore
                code.map((it)=>$a9462d9f7870d0d5$export$b3890eb0ae9dca99(it, `${tabs}\t`)
                ).join(`,\n${tabs}\t`)}
${tabs}`;
                // @ts-ignore
                return `[${code.length ? content : ""}]`;
            }
            if (typeof code === "object") {
                const keys = Object.keys(code);
                return keys.length ? `[
${tabs}\t${keys.map((key)=>`"${key}" : ${$a9462d9f7870d0d5$export$b3890eb0ae9dca99(code[key], `${tabs}\t`)}`
                ).join(`,\n\t${tabs}`)}
${tabs}]` : "[:]";
            }
            if (typeof code === "number") return `Double(${code})`;
            return JSON.stringify(code);
    }
};


const $54ccefa5a416848d$export$1f0ba71ea6f249e7 = (dependencies)=>[
        {
            dependency: "_",
            code: "var _ = {}"
        },
        {
            dependency: "_.slice",
            code: `
_.slice = function(list, from, to) {
	return list.slice(from, to);
};`
        },
        {
            dependency: "_.replace",
            code: `
_.replace = function(input, find, replace) {
	return input.replace(typeof find === "object" ? new RegExp(find.pattern, find.flags) : find, replace)
};`
        },
        {
            dependency: "_.split",
            code: `
_.split = function(input, separator, limit) {
	return input.split(typeof separator === "object" ? new RegExp(separator.pattern, separator.flags) : separator, limit)
};`
        },
        {
            dependency: "_.sort",
            code: `
_.sort = function(list, callback) {
	return list.sort(function (a, b) {
		return callback({
			a : a,
			b : b
		});
	});
};`
        },
        {
            dependency: "_.reduce",
            code: `
_.reduce = function(list, callback, start) {
	return list.reduce(function(total, item, index) {
		return callback({
			total : total,
			index : index,
			item : item
		})
	}, start);
};`
        },
        {
            dependency: "_.upsert",
            code: `
_.upsert = function(list, upsert) {
	var item = list.find(function(item) {
		return (item.id && upsert.id && item.id === upsert.id) || (item.key && upsert.key && item.key === upsert.key)
	})
	if(item) {
		var index = list.indexOf(item);
		return [].concat(list.slice(0, index), [Object.assign(item, upsert)], list.slice(index + 1));
	} else {
		return list.concat([upsert]);
	}
};
`
        },
        {
            dependency: "_.keys",
            code: `
_.keys = function(target) {
	return Object.keys(target);
};
`
        },
        {
            dependency: "_.assign",
            code: `
_.assign = function() {
	return Object.assign.apply(null, arguments);
};`
        },
        {
            dependency: "_.toLowerCase",
            code: `
_.toLowerCase = function(target) {
	return target.toLowerCase();
};`
        },
        {
            dependency: "_.forEach",
            code: `
_.forEach = function(list, callback) {
	return list.forEach(function(item, index, items) {
		return callback({
			item : item,
			index : index,
			items : items
		})
	})
};`
        },
        {
            dependency: "_.map",
            code: `
_.map = function(list, callback) {
	return list.map(function(item, index, items) {
		return callback({
			item : item,
			index : index,
			items : items
		})
	})
};`
        },
        {
            dependency: "_.shuffle",
            code: `
_.shuffle = function(array) {
	for(let i = 0; i < array.length; ++i) {
		var j = Math.floor(Math.random() * array.length);
		var temp = array[i];
		array[i] = array[j];
		array[j] = temp;
	}
	return array;
};`
        },
        {
            dependency: "_.some",
            code: `
_.some = function(list, callback) {
	return list.some(function(item) {
		return callback({
			item : item
		})
	})
};`
        },
        {
            dependency: "_.every",
            code: `
_.every = function(list, callback) {
	return list.every(function(item) {
		return callback({
			item : item
		})
	})
};`
        },
        {
            dependency: "_.includes",
            code: `
_.includes = function(list, item) {
	return list.includes(item)
};`
        },
        {
            dependency: "_.filter",
            code: `
_.filter = function(list, callback) {
	return list.filter(function(item, index) {
		return callback({
			item : item,
			index : index
		})
	})
};`
        },
        {
            dependency: "_.toString",
            code: `
_.toString = function(input) {
	return "" + input;
};`
        },
        {
            dependency: "_.toInt",
            code: `
_.toInt = function(input) {
	return parseInt(input, 10);
};`
        },
        {
            dependency: "_.toFloat",
            code: `
_.toFloat = function(input) {
	return parseFloat(input);
};`
        },
        {
            dependency: "_.join",
            code: `
_.join = function(target, separator) {
	return target.join(separator);
};
`
        },
        {
            dependency: "_.concat",
            code: `
_.concat = function() {
	return [].concat.apply([], arguments);
};
`
        },
        {
            dependency: "_.indexOf",
            code: `
_.indexOf = function(list, callback) {
	var item = list.find(function(item) {
		return callback({
			item : item
		});
	});
	return list.indexOf(item);
};`
        },
        {
            dependency: "_.find",
            code: `
_.find = function(list, callback, or) {
	return list.find(function(item) {
		return callback({
			item : item
		});
	}) || or;
};`
        },
        {
            dependency: "_.compare",
            code: `
_.compare = function(a, b) {
	return a.localeCompare(b);
};`
        },
        {
            dependency: "fetch",
            code: `
var windowFetch = fetch;
var fetch = (function(url, config) {
	return function(url, config) {
		windowFetch(url, {
			method : config.method,
			body : config.body,
			headers : config.headers,
			credentials : config.credentials
		}).then(function(res) {
			return res.text().then(function(text) {
				config.callback({
					response : {
						status : res.status,
						body : text,
						headers : res.headers
					}
				});
				update();
			})
		}).catch(function(error) {
			config.callback({
				error : error
			});
			update();
		});
	}
})();`
        }
    ].filter(({ dependency: dependency  })=>dependencies.has(dependency)
    ).map((it)=>it.code.trim()
    ).join("\n") + `
var fallback = function(a, b) {
	return a === undefined || a === null ? b : a;
};`
;
const $54ccefa5a416848d$var$variableRegexp = /^[a-zA-Z_$][0-9a-zA-Z_$]*$/;
const $54ccefa5a416848d$var$wrapKey = (input)=>{
    if (input.match($54ccefa5a416848d$var$variableRegexp)) return input;
    return `"${input}"`;
};
const $54ccefa5a416848d$var$renderPath = (path, tabs)=>{
    return path.map((it, index)=>{
        if (typeof it === "string") return `${index ? "." : ""}${it}`;
        return index ? `[${$54ccefa5a416848d$export$b3890eb0ae9dca99(it, tabs)}]` : $54ccefa5a416848d$export$b3890eb0ae9dca99(it, tabs);
    }).join("");
};
const $54ccefa5a416848d$export$b3890eb0ae9dca99 = (code, tabs)=>{
    if (code === null) return "null";
    if (code === undefined) return "";
    if (code instanceof RegExp) return $54ccefa5a416848d$export$b3890eb0ae9dca99({
        pattern: code.source,
        flags: code.flags
    }, tabs);
    switch(code._name){
        case "condition":
            {
                const otherwise = code.otherwise ? ` else {
${$54ccefa5a416848d$export$b3890eb0ae9dca99(code.otherwise, tabs + "\t")}
${tabs}}` : "";
                return `${tabs}if(${$54ccefa5a416848d$export$b3890eb0ae9dca99(code.test, tabs)}) {
${$54ccefa5a416848d$export$b3890eb0ae9dca99(code.then, tabs + "\t")}
${tabs}}${otherwise}`;
            }
        case "declare":
            {
                const keys = Object.keys(code.variables);
                const variables = keys.length ? `${tabs}var ${keys.map((key)=>{
                    // @ts-ignore
                    return `${key} = ${$54ccefa5a416848d$export$b3890eb0ae9dca99(code.variables[key], tabs)}`;
                }).join(", ")};\n` : "";
                const body = code.body.map((it)=>$54ccefa5a416848d$export$b3890eb0ae9dca99(it, tabs)
                ).join("\n");
                return `${variables}${body}`;
            }
        case "set":
            return `${tabs}${$54ccefa5a416848d$var$renderPath(code.variable, tabs)} = ${$54ccefa5a416848d$export$b3890eb0ae9dca99(code.value, tabs)};`;
        case "get":
            return $54ccefa5a416848d$var$renderPath(code.variable, tabs);
        case "invoke":
            {
                const target = $54ccefa5a416848d$export$b3890eb0ae9dca99(code.target, tabs);
                const fun = code.fun;
                const args = code.args.map((it)=>$54ccefa5a416848d$export$b3890eb0ae9dca99(it, tabs)
                );
                const sideEffect = code.sideEffect;
                return `${sideEffect ? tabs : ""}${target}${target ? "." : ""}${fun}(${args.join(", ")})${sideEffect ? ";" : ""}`;
            }
        case "execute":
            return "";
        case "not":
            return `!(${$54ccefa5a416848d$export$b3890eb0ae9dca99(code.item, tabs)})`;
        case "add":
            return "(" + code.items.map((it)=>$54ccefa5a416848d$export$b3890eb0ae9dca99(it, tabs)
            ).join(" + ") + ")";
        case "sub":
            return "(" + code.items.map((it)=>$54ccefa5a416848d$export$b3890eb0ae9dca99(it, tabs)
            ).join(" - ") + ")";
        case "mult":
            return "(" + code.items.map((it)=>$54ccefa5a416848d$export$b3890eb0ae9dca99(it, tabs)
            ).join(" * ") + ")";
        case "div":
            return "(" + code.items.map((it)=>$54ccefa5a416848d$export$b3890eb0ae9dca99(it, tabs)
            ).join(" / ") + ")";
        case "or":
            return "(" + code.items.map((it)=>$54ccefa5a416848d$export$b3890eb0ae9dca99(it, tabs)
            ).join(" || ") + ")";
        case "and":
            return "(" + code.items.map((it)=>$54ccefa5a416848d$export$b3890eb0ae9dca99(it, tabs)
            ).join(" && ") + ")";
        case "gt":
            return `(${$54ccefa5a416848d$export$b3890eb0ae9dca99(code.a, tabs)} > ${$54ccefa5a416848d$export$b3890eb0ae9dca99(code.b, tabs)})`;
        case "lt":
            return `(${$54ccefa5a416848d$export$b3890eb0ae9dca99(code.a, tabs)} < ${$54ccefa5a416848d$export$b3890eb0ae9dca99(code.b, tabs)})`;
        case "gte":
            return `(${$54ccefa5a416848d$export$b3890eb0ae9dca99(code.a, tabs)} >= ${$54ccefa5a416848d$export$b3890eb0ae9dca99(code.b, tabs)})`;
        case "eq":
            return `(${$54ccefa5a416848d$export$b3890eb0ae9dca99(code.a, tabs)} === ${$54ccefa5a416848d$export$b3890eb0ae9dca99(code.b, tabs)})`;
        case "result":
            return `${tabs}return ${$54ccefa5a416848d$export$b3890eb0ae9dca99(code.value, tabs)};`;
        case "fun":
            {
                const body = [
                    ...code.args.map((it)=>`${tabs}\tvar ${it} = args.${it};`
                    ),
                    $54ccefa5a416848d$export$b3890eb0ae9dca99(code.body, `${tabs}\t`)
                ];
                return `${code.name ? `${code.name} = ` : ""}function (${code.args.length ? "args" : ""}) {
${body.join("\n")}
${tabs}}`;
            }
        case "defined":
            {
                const value = $54ccefa5a416848d$export$b3890eb0ae9dca99(code.item, "");
                return `${value} !== undefined && ${value} !== null`;
            }
        case "fallback":
            {
                const value = $54ccefa5a416848d$export$b3890eb0ae9dca99(code.value, tabs);
                const fallback = $54ccefa5a416848d$export$b3890eb0ae9dca99(code.fallback, tabs);
                return `fallback(${value}, ${fallback})`;
            }
        default:
            // @ts-ignore
            if (code instanceof Array) // @ts-ignore
            return `[${code.map((it)=>$54ccefa5a416848d$export$b3890eb0ae9dca99(it, tabs)
            ).join(", ")}]`;
            if (typeof code === "object") {
                const keys = Object.keys(code);
                return keys.length ? `{
${tabs}\t${keys.map((key)=>`${$54ccefa5a416848d$var$wrapKey(key)}: ${$54ccefa5a416848d$export$b3890eb0ae9dca99(code[key], `${tabs}\t`)}`
                ).join(`,\n\t${tabs}`)}
${tabs}}` : "{}";
            }
            return JSON.stringify(code);
    }
};


const $882b6d93070905b3$export$a55877ca9db47377 = (value)=>(input)=>{
        return Object.keys(input).reduce(($882b6d93070905b3$export$6565f9f03506010b, key)=>$882b6d93070905b3$export$355ef19165780f94($882b6d93070905b3$export$9663ddc1cf085b32(key, value), input[key]).otherwise($882b6d93070905b3$export$6565f9f03506010b)
        , $882b6d93070905b3$export$837bd02682cd3db9([]));
    }
;
const $882b6d93070905b3$var$wrapResult = ($882b6d93070905b3$export$aaf36426b5008f7a)=>{
    if (typeof $882b6d93070905b3$export$aaf36426b5008f7a === "string") return new String($882b6d93070905b3$export$aaf36426b5008f7a);
    if (typeof $882b6d93070905b3$export$aaf36426b5008f7a === "number") return new Number($882b6d93070905b3$export$aaf36426b5008f7a);
    if (typeof $882b6d93070905b3$export$aaf36426b5008f7a === "boolean") return new Boolean($882b6d93070905b3$export$aaf36426b5008f7a);
    if ($882b6d93070905b3$export$aaf36426b5008f7a === undefined || $882b6d93070905b3$export$aaf36426b5008f7a === null) return {
    };
    return $882b6d93070905b3$export$aaf36426b5008f7a;
};
const $882b6d93070905b3$export$468cda29b159ee5d = ({ fun: fun , args: args , target: target , sideEffect: sideEffect , dependencies: dependencies  })=>({
        _name: "invoke",
        target: target,
        fun: fun,
        args: args.map($882b6d93070905b3$var$useCode),
        sideEffect: sideEffect,
        dependencies: Array.from(dependencies)
    })
;
const $882b6d93070905b3$export$923f96dd5afa9ce6 = ({ scope: scope , path: path , dependencies: dependencies  })=>new Proxy({
    }, {
        set () {
            return false;
        },
        get (_, key) {
            if (key === "_code") {
                const ret = scope?._code ?? {
                    _name: "get",
                    variable: path
                };
                ret.dependencies = Array.from(dependencies);
                return ret;
            }
            const prop = scope[key] ?? {
            };
            const codePath = scope._code;
            const nextPath = [
                ...path,
                ...codePath ? [
                    codePath
                ] : [],
                $882b6d93070905b3$var$useCode(key)
            ];
            if (nextPath.every((it)=>[
                    "string",
                    "number"
                ].includes(typeof it)
            )) dependencies.add(nextPath.join("."));
            if (typeof prop === "function" || key.toString().match(/^on[A-Z]/)) return (...args)=>{
                const $882b6d93070905b3$export$aaf36426b5008f7a = typeof prop === "function" ? prop.call(scope) : null;
                const wrapped = $882b6d93070905b3$var$wrapResult($882b6d93070905b3$export$aaf36426b5008f7a);
                wrapped._code = $882b6d93070905b3$export$468cda29b159ee5d({
                    target: scope._code ?? {
                        _name: "get",
                        variable: path
                    },
                    fun: key,
                    args: args.map($882b6d93070905b3$var$useCode),
                    sideEffect: $882b6d93070905b3$export$aaf36426b5008f7a === undefined,
                    dependencies: dependencies
                });
                return $882b6d93070905b3$export$923f96dd5afa9ce6({
                    dependencies: dependencies,
                    path: [],
                    scope: wrapped
                });
            };
            return $882b6d93070905b3$export$923f96dd5afa9ce6({
                scope: $882b6d93070905b3$var$wrapResult(prop),
                path: nextPath,
                dependencies: dependencies
            });
        }
    })
;
const $882b6d93070905b3$var$useCode = (it1)=>{
    if (it1 === undefined || it1 === null) return null;
    // @ts-ignore
    const $882b6d93070905b3$export$6565f9f03506010b = it1._code;
    if ($882b6d93070905b3$export$6565f9f03506010b) // @ts-ignore
    return $882b6d93070905b3$export$6565f9f03506010b;
    if (it1 instanceof Array) return it1.map($882b6d93070905b3$var$useCode);
    // @ts-ignore
    if (typeof it1 === "object" && !it1._name) // @ts-ignore
    Object.keys(it1).forEach((key)=>{
        // @ts-ignore
        it1[key] = $882b6d93070905b3$var$useCode(it1[key]);
    });
    if (typeof it1 === "function") {
        const dependencies = new Set([]);
        const scope = {
        };
        const body = it1($882b6d93070905b3$export$923f96dd5afa9ce6({
            scope: scope,
            path: [],
            dependencies: dependencies
        }));
        return {
            _name: "fun",
            name: "",
            args: Array.from(dependencies).filter((it)=>!it.includes(".")
            ),
            body: $882b6d93070905b3$var$useCode(body)
        };
    }
    return it1;
};
const $882b6d93070905b3$export$355ef19165780f94 = (test, then)=>{
    return {
        // @ts-ignore
        _code: {
            _name: "condition",
            test: $882b6d93070905b3$var$useCode(test),
            then: $882b6d93070905b3$var$useCode(then)
        },
        otherwise: (otherwise)=>({
                _code: {
                    _name: "condition",
                    test: $882b6d93070905b3$var$useCode(test),
                    then: $882b6d93070905b3$var$useCode(then),
                    otherwise: $882b6d93070905b3$var$useCode(otherwise)
                }
            })
    };
};
const $882b6d93070905b3$var$PollyDate = {
    now: Date.now
};
const $882b6d93070905b3$var$GET_STRING = ()=>""
;
const $882b6d93070905b3$var$GET_OBJECT = ()=>({
    })
;
const $882b6d93070905b3$var$GET_BOOLEAN = ()=>false
;
const $882b6d93070905b3$var$GET_NUMBER = ()=>0
;
const $882b6d93070905b3$var$GET_ARRAY = ()=>[]
;
const $882b6d93070905b3$var$GET_VOID = ()=>{
// DO NOTHING
};
const $882b6d93070905b3$var$getProxy = ({ scope: scope , dependencies: dependencies  })=>$882b6d93070905b3$export$923f96dd5afa9ce6({
        scope: {
            JSON: {
                stringify: $882b6d93070905b3$var$GET_STRING,
                parse: $882b6d93070905b3$var$GET_OBJECT
            },
            fetch: $882b6d93070905b3$var$GET_VOID,
            Math: Math,
            Date: $882b6d93070905b3$var$PollyDate,
            console: {
                log: $882b6d93070905b3$var$GET_VOID
            },
            setTimeout: $882b6d93070905b3$var$GET_NUMBER,
            debounce: $882b6d93070905b3$var$GET_NUMBER,
            throttle: $882b6d93070905b3$var$GET_NUMBER,
            parseFloat: $882b6d93070905b3$var$GET_NUMBER,
            socket: {
                on: $882b6d93070905b3$var$GET_VOID
            },
            promise: $882b6d93070905b3$var$GET_OBJECT,
            _: {
                join: $882b6d93070905b3$var$GET_STRING,
                keys: $882b6d93070905b3$var$GET_ARRAY,
                toLowerCase: $882b6d93070905b3$var$GET_STRING,
                split: $882b6d93070905b3$var$GET_ARRAY,
                toString: $882b6d93070905b3$var$GET_STRING,
                toInt: $882b6d93070905b3$var$GET_NUMBER,
                toFloat: $882b6d93070905b3$var$GET_NUMBER,
                some: $882b6d93070905b3$var$GET_BOOLEAN,
                every: $882b6d93070905b3$var$GET_BOOLEAN,
                indexOf: ()=>-1
                ,
                compare: $882b6d93070905b3$var$GET_NUMBER,
                sort: $882b6d93070905b3$var$GET_ARRAY,
                map: $882b6d93070905b3$var$GET_ARRAY,
                forEach: $882b6d93070905b3$var$GET_VOID,
                reduce: (items, callback, initial)=>initial || {
                    }
                ,
                slice: $882b6d93070905b3$var$GET_ARRAY,
                replace: $882b6d93070905b3$var$GET_STRING,
                filter: $882b6d93070905b3$var$GET_ARRAY,
                includes: $882b6d93070905b3$var$GET_BOOLEAN,
                concat: $882b6d93070905b3$var$GET_ARRAY,
                assign: $882b6d93070905b3$var$GET_OBJECT,
                find: $882b6d93070905b3$var$GET_OBJECT,
                upsert: $882b6d93070905b3$var$GET_ARRAY,
                shuffle: $882b6d93070905b3$var$GET_ARRAY
            },
            ...scope
        },
        path: [],
        dependencies: dependencies
    })
;
const $882b6d93070905b3$export$6565f9f03506010b = (callback, dependencies, scope)=>{
    return $882b6d93070905b3$var$useCode(callback($882b6d93070905b3$var$getProxy({
        scope: scope,
        dependencies: dependencies
    })));
};
class $882b6d93070905b3$var$Result {
    constructor(value){
        this.value = value;
    }
}
function $882b6d93070905b3$export$8f701197936bc2a6(variable, index) {
    const path = $882b6d93070905b3$var$useCode(variable);
    const dependencies = new Set([]);
    // TODO make this better
    if (path._name === "fallback" || path._name === "invoke") return $882b6d93070905b3$export$923f96dd5afa9ce6({
        scope: {
        },
        dependencies: dependencies,
        path: [
            path,
            $882b6d93070905b3$var$useCode(index)
        ]
    });
    else return $882b6d93070905b3$export$923f96dd5afa9ce6({
        scope: {
        },
        dependencies: dependencies,
        path: [
            ...path.variable,
            $882b6d93070905b3$var$useCode(index)
        ]
    });
}
const $882b6d93070905b3$export$e16d8520af44a096 = (...items)=>{
    // @ts-ignore
    return {
        _name: "add",
        items: items.map($882b6d93070905b3$var$useCode)
    };
};
const $882b6d93070905b3$export$252bb8b3bbdf6749 = (...items)=>{
    // @ts-ignore
    return {
        _name: "or",
        items: items.map($882b6d93070905b3$var$useCode)
    };
};
const $882b6d93070905b3$export$21c0ac7fe1cef1b8 = (...items)=>{
    // @ts-ignore
    return {
        _name: "and",
        items: items.map($882b6d93070905b3$var$useCode)
    };
};
const $882b6d93070905b3$export$f93b5905241a7cca = (...items)=>{
    // @ts-ignore
    return {
        _name: "sub",
        items: items.map($882b6d93070905b3$var$useCode)
    };
};
const $882b6d93070905b3$export$6003a5f097c73977 = (item)=>{
    // @ts-ignore
    return {
        _name: "not",
        item: $882b6d93070905b3$var$useCode(item)
    };
};
const $882b6d93070905b3$export$43f40ad3fa1d5c97 = (item)=>{
    // @ts-ignore
    return {
        _name: "defined",
        item: $882b6d93070905b3$var$useCode(item)
    };
};
const $882b6d93070905b3$export$30cdb7d48dedb58b = (...items)=>{
    // @ts-ignore
    return {
        _name: "mult",
        items: items.map($882b6d93070905b3$var$useCode)
    };
};
const $882b6d93070905b3$export$159d9494db57879b = (...items)=>{
    // @ts-ignore
    return {
        _name: "div",
        items: items.map($882b6d93070905b3$var$useCode)
    };
};
const $882b6d93070905b3$export$aac79e834d1b4aed = (a, b)=>{
    // @ts-ignore
    return {
        _name: "gte",
        a: $882b6d93070905b3$var$useCode(a),
        b: $882b6d93070905b3$var$useCode(b)
    };
};
const $882b6d93070905b3$export$dafeacbfe3530cd9 = (a, b)=>{
    // @ts-ignore
    return {
        _name: "gt",
        a: $882b6d93070905b3$var$useCode(a),
        b: $882b6d93070905b3$var$useCode(b)
    };
};
const $882b6d93070905b3$export$b961576059b7aeb6 = (a, b)=>{
    // @ts-ignore
    return {
        _name: "lt",
        a: $882b6d93070905b3$var$useCode(a),
        b: $882b6d93070905b3$var$useCode(b)
    };
};
const $882b6d93070905b3$export$9663ddc1cf085b32 = (a, b)=>{
    // @ts-ignore
    return {
        _name: "eq",
        a: $882b6d93070905b3$var$useCode(a),
        b: $882b6d93070905b3$var$useCode(b)
    };
};
const $882b6d93070905b3$export$bcd1dd1f397bba12 = (value, $882b6d93070905b3$export$bcd1dd1f397bba12)=>{
    // @ts-ignore
    return $882b6d93070905b3$export$923f96dd5afa9ce6({
        scope: {
        },
        dependencies: new Set([]),
        path: [
            {
                _name: "fallback",
                value: $882b6d93070905b3$var$useCode(value),
                fallback: $882b6d93070905b3$var$useCode($882b6d93070905b3$export$bcd1dd1f397bba12)
            }
        ]
    });
};
const $882b6d93070905b3$export$aaf36426b5008f7a = (input)=>{
    return {
        _name: "result",
        value: $882b6d93070905b3$var$useCode(input)
    };
};
const $882b6d93070905b3$export$adaa4cf7ef1b65be = (variable, value)=>{
    // @ts-ignore
    const $882b6d93070905b3$export$6565f9f03506010b = variable._code;
    return {
        _name: "set",
        // @ts-ignore
        variable: $882b6d93070905b3$export$6565f9f03506010b ? $882b6d93070905b3$export$6565f9f03506010b.variable : variable.variable ?? variable,
        value: $882b6d93070905b3$var$useCode(value)
    };
};
const $882b6d93070905b3$export$2dd1b52e6ceca94e = (callback, variables1)=>{
    const scope = Object.keys(variables1).reduce((variables, key)=>{
        // @ts-ignore
        variables[key] = $882b6d93070905b3$var$useCode(variables[key]);
        return variables;
    }, variables1);
    const body = callback($882b6d93070905b3$export$923f96dd5afa9ce6({
        scope: scope,
        path: [],
        dependencies: new Set([])
    }));
    return {
        _name: "declare",
        variables: scope,
        body: body.map($882b6d93070905b3$var$useCode)
    };
};
const $882b6d93070905b3$export$837bd02682cd3db9 = (input)=>$882b6d93070905b3$export$2dd1b52e6ceca94e(()=>input
    , {
    })
;
const $882b6d93070905b3$var$getFromScope = (name, scope, prop)=>{
    if (name.length === 0) {
        for(let i = scope.length - 1; i >= 0; i--){
            if (prop in scope[i]) return scope[i];
        }
        return scope[0];
    }
    for(let i = scope.length - 1; i >= 0; i--)// @ts-ignore
    if (typeof name[0] === "object" || name[0] in scope[i]) {
        let value = typeof name[0] === "object" ? name[0] : scope[i][name[0]];
        for(let j = 1; j < name.length; j++)if (value != null && value !== undefined) value = value[name[j]];
        return value;
    }
};
const $882b6d93070905b3$export$cf30d3d2f53b889d = ($882b6d93070905b3$export$6565f9f03506010b)=>({
        _name: "execute",
        code: $882b6d93070905b3$export$6565f9f03506010b
    })
;
const $882b6d93070905b3$export$51396ec711da548b = ($882b6d93070905b3$export$6565f9f03506010b, scope)=>{
    const $882b6d93070905b3$export$aaf36426b5008f7a = $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b, [
        {
            JSON: JSON,
            Math: Math,
            console: console,
            Date: $882b6d93070905b3$var$PollyDate,
            encodeURIComponent: encodeURIComponent,
            parseFloat: parseFloat,
            fetch: ()=>{
            // DO NOTHING
            },
            socket: {
                on: ()=>{
                // DO NOTHING
                }
            },
            promise: (callback)=>new Promise((onResolve, onReject)=>callback({
                        onResolve: onResolve,
                        onReject: onReject
                    })
                )
            ,
            _: {
                join: (target, separator)=>target.join(separator)
                ,
                keys: (input)=>Object.keys(input)
                ,
                toLowerCase: (input)=>input.toLowerCase()
                ,
                split: (input, token)=>{
                    return input.split(typeof token === "string" ? token : new RegExp(token.pattern, token.flags));
                },
                concat: (...items)=>{
                    return items.reduce((total, list)=>list ? [
                            ...total,
                            ...list
                        ] : total
                    , []);
                },
                toString: (input)=>`${input}`
                ,
                toInt: (input)=>parseInt(input, 10)
                ,
                toFloat: (input)=>parseFloat(input)
                ,
                slice: (items, from, to)=>{
                    if (!items) return [];
                    return items.slice(from, to);
                },
                replace: (haystack, needle, replace)=>{
                    if (!haystack) return "";
                    return haystack.replace(typeof needle === "string" ? needle : new RegExp(needle.pattern, needle.flags), replace);
                },
                reduce: (items, callback, initial)=>{
                    if (!items) return initial;
                    return items.reduce((total, item, index)=>{
                        return callback({
                            item: item,
                            total: total,
                            index: index
                        });
                    }, initial);
                },
                map: (items, callback)=>{
                    if (!items) return [];
                    return items.map((item, index)=>{
                        return callback({
                            item: item,
                            index: index
                        });
                    });
                },
                forEach: (items, callback)=>{
                    if (!items) return;
                    items.forEach((item, index)=>{
                        return callback({
                            item: item,
                            index: index
                        });
                    });
                },
                find: (items, callback, $882b6d93070905b3$export$252bb8b3bbdf6749)=>{
                    if (!items) return $882b6d93070905b3$export$252bb8b3bbdf6749;
                    return items.find((item)=>{
                        return callback({
                            item: item
                        });
                    }) ?? $882b6d93070905b3$export$252bb8b3bbdf6749;
                },
                filter: (items, callback)=>{
                    if (!items) return [];
                    return items.filter((item, index)=>{
                        return callback({
                            item: item,
                            index: index
                        });
                    });
                },
                compare: (a, b)=>{
                    if (typeof a === "string" && typeof b === "string") return a.localeCompare(b);
                    if (typeof a === "number" && typeof b === "number") return a - b;
                    return 0;
                },
                indexOf: (haystack, callback)=>{
                    const item = haystack.find(callback);
                    return item ? haystack.indexOf(item) : -1;
                },
                some: (items, callback)=>{
                    if (!items) return false;
                    return items.some((item)=>{
                        return callback({
                            item: item
                        });
                    });
                },
                every: (items, callback)=>{
                    if (!items) return false;
                    return items.every((item)=>{
                        return callback({
                            item: item
                        });
                    });
                },
                assign: (...args)=>{
                    return args.slice(1).reduce((total, overwrite)=>Object.assign(total || {
                        }, overwrite)
                    , args[0]);
                },
                includes: (haystack, needle)=>{
                    return haystack.includes(needle);
                },
                shuffle: (array)=>{
                    for(let i = 0; i < array.length; ++i){
                        const j = Math.floor(Math.random() * array.length);
                        const temp = array[i];
                        array[i] = array[j];
                        array[j] = temp;
                    }
                    return array;
                },
                sort: (array, sort)=>{
                    return array.sort((a, b)=>{
                        return sort({
                            a: a,
                            b: b
                        });
                    });
                }
            },
            ...scope
        }
    ]);
    if ($882b6d93070905b3$export$aaf36426b5008f7a instanceof $882b6d93070905b3$var$Result) return $882b6d93070905b3$export$aaf36426b5008f7a.value;
    return $882b6d93070905b3$export$aaf36426b5008f7a;
};
const $882b6d93070905b3$var$executeBody = (body, scope)=>{
    let $882b6d93070905b3$export$aaf36426b5008f7a;
    for(let i = 0; i < body.length; i++){
        $882b6d93070905b3$export$aaf36426b5008f7a = $882b6d93070905b3$var$executeWithScope(body[i], scope);
        if ($882b6d93070905b3$export$aaf36426b5008f7a instanceof $882b6d93070905b3$var$Result) return $882b6d93070905b3$export$aaf36426b5008f7a;
    }
    return $882b6d93070905b3$export$aaf36426b5008f7a;
};
const $882b6d93070905b3$var$executeWithScope = ($882b6d93070905b3$export$6565f9f03506010b, scope)=>{
    if ($882b6d93070905b3$export$6565f9f03506010b === undefined || $882b6d93070905b3$export$6565f9f03506010b === null) return $882b6d93070905b3$export$6565f9f03506010b;
    switch($882b6d93070905b3$export$6565f9f03506010b._name){
        case "condition":
            {
                const test = $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.test, scope);
                if (test) return $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.then, [
                    ...scope,
                    {
                    }
                ]);
                else if ($882b6d93070905b3$export$6565f9f03506010b.otherwise) return $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.otherwise, [
                    ...scope,
                    {
                    }
                ]);
                return;
            }
        case "declare":
            Object.keys($882b6d93070905b3$export$6565f9f03506010b.variables).forEach((key)=>{
                // @ts-ignore
                scope[scope.length - 1][key] = $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.variables[key], scope);
            });
            return $882b6d93070905b3$var$executeBody($882b6d93070905b3$export$6565f9f03506010b.body, scope);
        case "get":
            if ($882b6d93070905b3$export$6565f9f03506010b.variable.length === 1 && $882b6d93070905b3$export$6565f9f03506010b.variable[0]._name === "fallback") return $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.variable[0], scope);
            return $882b6d93070905b3$var$getFromScope($882b6d93070905b3$export$6565f9f03506010b.variable.map((it)=>$882b6d93070905b3$var$executeWithScope(it, scope)
            ), scope, "");
        case "defined":
            {
                const value = $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.item, scope);
                return value !== undefined && value !== null;
            }
        case "set":
            {
                const target = $882b6d93070905b3$export$6565f9f03506010b.variable.map((it)=>$882b6d93070905b3$var$executeWithScope(it, scope)
                );
                const prop = target.pop();
                const variable = $882b6d93070905b3$var$getFromScope(target, scope, prop);
                if (variable !== undefined && variable !== null && prop !== undefined && prop !== null) {
                    const value = $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.value, scope);
                    // @ts-ignore
                    variable[prop] = value;
                }
                return;
            }
        case "invoke":
            {
                const target = $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.target, scope);
                const prop = $882b6d93070905b3$export$6565f9f03506010b.fun;
                const args = $882b6d93070905b3$export$6565f9f03506010b.args.map((it)=>$882b6d93070905b3$var$executeWithScope(it, scope)
                );
                const fun = $882b6d93070905b3$var$getFromScope([
                    prop
                ], scope, "");
                if (target === null || target === undefined) {
                    if (fun) return fun(...args);
                // @ts-ignore
                } else if (target[prop]) // @ts-ignore
                return target[prop](...args);
                console.warn("unimplemented functionality", $882b6d93070905b3$export$6565f9f03506010b, target, prop, args);
                return null;
            }
        case "add":
            {
                const first = $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.items[0], scope);
                return $882b6d93070905b3$export$6565f9f03506010b.items.slice(1).reduce((total, it)=>total + $882b6d93070905b3$var$executeWithScope(it, scope)
                , first);
            }
        case "sub":
            {
                const first = $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.items[0], scope);
                return $882b6d93070905b3$export$6565f9f03506010b.items.slice(1).reduce((total, it)=>total - $882b6d93070905b3$var$executeWithScope(it, scope)
                , first);
            }
        case "mult":
            return $882b6d93070905b3$export$6565f9f03506010b.items.reduce((total, it)=>total * $882b6d93070905b3$var$executeWithScope(it, scope)
            , 1);
        case "div":
            {
                const first = $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.items[0], scope);
                return $882b6d93070905b3$export$6565f9f03506010b.items.slice(1).reduce((total, it)=>total / $882b6d93070905b3$var$executeWithScope(it, scope)
                , first);
            }
        case "or":
            return $882b6d93070905b3$export$6565f9f03506010b.items.reduce((total, it)=>total || $882b6d93070905b3$var$executeWithScope(it, scope)
            , false);
        case "and":
            return $882b6d93070905b3$export$6565f9f03506010b.items.reduce((total, it)=>total && $882b6d93070905b3$var$executeWithScope(it, scope)
            , true);
        case "gt":
            return $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.a, scope) > $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.b, scope);
        case "lt":
            return $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.a, scope) < $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.b, scope);
        case "gte":
            return $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.a, scope) >= $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.b, scope);
        case "eq":
            return $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.a, scope) === $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.b, scope);
        case "not":
            return !$882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.item, scope);
        case "fun":
            {
                const fun = (args)=>{
                    const $882b6d93070905b3$export$aaf36426b5008f7a = $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.body, [
                        ...scope,
                        args || {
                        }
                    ]);
                    if ($882b6d93070905b3$export$aaf36426b5008f7a instanceof $882b6d93070905b3$var$Result) return $882b6d93070905b3$export$aaf36426b5008f7a.value;
                };
                if ($882b6d93070905b3$export$6565f9f03506010b.name) {
                    const [global, name] = $882b6d93070905b3$export$6565f9f03506010b.name.split(".");
                    scope[scope.length - 1][global][name] = fun;
                }
                return fun;
            }
        case "fallback":
            return $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.value, scope) ?? $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.fallback, scope);
        case "result":
            return new $882b6d93070905b3$var$Result($882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.value, scope));
        case "execute":
            return $882b6d93070905b3$var$executeWithScope($882b6d93070905b3$export$6565f9f03506010b.code, scope);
        default:
            {
                const data = $882b6d93070905b3$export$6565f9f03506010b;
                if (data instanceof Array) return data.map((object)=>$882b6d93070905b3$var$executeWithScope(object, scope)
                );
                if (typeof data === "object") return Object.keys(data).reduce((object, key)=>{
                    object[key] = $882b6d93070905b3$var$executeWithScope(data[key], scope);
                    return object;
                }, {
                });
            }
    }
    return $882b6d93070905b3$export$6565f9f03506010b;
};
const $882b6d93070905b3$export$18af1f934c132a41 = (name, $882b6d93070905b3$export$18af1f934c132a41, scope)=>{
    const dependencies = new Set([]);
    const ret = ()=>{
        const $882b6d93070905b3$export$2dd1b52e6ceca94e = {
            _name: "declare",
            variables: {
                [name]: {
                }
            },
            body: []
        };
        Object.keys(funcs).forEach((key)=>{
            const func = $882b6d93070905b3$var$useCode(funcs[key]);
            $882b6d93070905b3$export$2dd1b52e6ceca94e.body.push({
                _name: "fun",
                body: func.body,
                name: `${name}.${key}`,
                args: Array.from(func.args)
            });
        });
        return $882b6d93070905b3$export$2dd1b52e6ceca94e;
    };
    const funcs = $882b6d93070905b3$export$18af1f934c132a41($882b6d93070905b3$var$getProxy({
        dependencies: dependencies,
        scope: scope
    }));
    Object.keys(funcs).forEach((key)=>{
        ret[key] = (args)=>{
            const wrapped = $882b6d93070905b3$var$wrapResult({
            });
            wrapped._code = $882b6d93070905b3$export$468cda29b159ee5d({
                args: args ? [
                    args
                ] : [],
                fun: key,
                sideEffect: false,
                target: {
                    _name: "get",
                    variable: [
                        name
                    ]
                },
                dependencies: dependencies
            });
            return $882b6d93070905b3$export$923f96dd5afa9ce6({
                dependencies: dependencies,
                path: [],
                scope: wrapped
            });
        };
    });
    return ret;
};
const $882b6d93070905b3$export$75915f81f2a6540a = ($882b6d93070905b3$export$6565f9f03506010b, dependencies1 = new Set([]))=>{
    if (Array.isArray($882b6d93070905b3$export$6565f9f03506010b)) return $882b6d93070905b3$export$6565f9f03506010b.reduce((dependencies, item)=>$882b6d93070905b3$export$75915f81f2a6540a(item, dependencies)
    , dependencies1);
    else if (typeof $882b6d93070905b3$export$6565f9f03506010b === "object" && $882b6d93070905b3$export$6565f9f03506010b !== null) return Object.keys($882b6d93070905b3$export$6565f9f03506010b).reduce((dependencies, key)=>{
        if (key === "dependencies") {
            const value = $882b6d93070905b3$export$6565f9f03506010b.dependencies;
            if (Array.isArray(value)) value.forEach((it)=>dependencies.add(it)
            );
        }
        return $882b6d93070905b3$export$75915f81f2a6540a($882b6d93070905b3$export$6565f9f03506010b[key], dependencies);
    }, dependencies1);
    return dependencies1;
};


//# sourceMappingURL=index.js.map
